#include <neko.h>
#include <stdlib.h>
#include <iconv.h>


static field current_id;
#define ICONV_BUF_SIZE 255


static void iconv_open_error(int no, value to_code, value from_code);
static void iconv_conv_error(int no);

static value neko_iconv( value src_str, value to_code , value from_code) {
	char * v;
	value r;
	char *inbuf_p;
	char *outbuf_p;
	buffer result_buf;
	char * outbuf;
	size_t nconv, insize, outsize;
	iconv_t cd;
	
	if (
		!val_is_string(src_str) ||
		!val_is_string(to_code) ||
		!val_is_string(from_code)
	) {
		neko_error();
	}

	
	
	cd = iconv_open (val_string(to_code), val_string(from_code));
	if (cd == (iconv_t) -1) {
		iconv_open_error(errno, to_code, from_code);
	}
	
	outbuf = (char *)malloc(sizeof(char) * (ICONV_BUF_SIZE + 1));
	if(outbuf == NULL) failure("MEM ERROR");
	result_buf = alloc_buffer("");

	inbuf_p = val_string(src_str);
	outbuf_p = outbuf;
	insize = val_strlen(src_str) + 1;
	outsize = ICONV_BUF_SIZE;

	do {
		outbuf_p = outbuf;
		nconv = iconv (cd, &inbuf_p, &insize, &outbuf_p, &outsize);
		outbuf[ICONV_BUF_SIZE - outsize] = '\0';
		buffer_append(result_buf, outbuf);
		outsize = ICONV_BUF_SIZE;
	} while (nconv == (size_t) -1 && errno == E2BIG);



	if (nconv == (size_t) -1) {
		free(outbuf);
		iconv_conv_error(errno);
	};

	iconv_close(cd);
 
	r = buffer_to_string(result_buf);
	free(outbuf);
	return r;
}


static void iconv_open_error(int no, value to_code, value from_code){
	buffer b;
	b = alloc_buffer("");
	if (no == EINVAL) {
		buffer_append(b, "The conversion from ");
		buffer_append(b, val_string(from_code));
		buffer_append(b, " to ");
		buffer_append(b, val_string(to_code));
		buffer_append(b, " is not supported by the implementation.");
	} else {
		buffer_append(b, "Error");
	}
	bfailure(b);
}

static void iconv_conv_error(int no){
	buffer b;
	b = alloc_buffer("");
	if (no == EINVAL) {
		buffer_append(b, "An incomplete multibyte sequence has been encountered in the input.");
	} else if (no == EILSEQ) {
		buffer_append(b, "An invalid multibyte sequence has been encountered in the input.");
	} else {
		buffer_append(b, "Error");
	}
	bfailure(error_buf);
}


// ---------------------------------------------------------------
// Registers

static void init() {
	current_id = val_id("current");
}

DEFINE_ENTRY_POINT(init);
DEFINE_PRIM(neko_iconv,3);


/* ************************************************************************ */
